
// Base Style

.btn {
    display: inline-flex; // for icons font
    justify-content: center;
    align-items: center;
    font-family: $btn-font-family;
    color: $btn-color;
    text-align: center;
    white-space: $btn-white-space;
    vertical-align: middle;
    cursor: if($enable-pointer-cursor-for-buttons, pointer, null);
    user-select: none;
    background-color: $white;
    border: $btn-border-width solid $btn-border-color;
    @include button-size($btn-padding-y, $btn-padding-x, $btn-font-size, $btn-line-height, $btn-border-radius);
    @include transition($btn-transition);
  
    @include hover() {
      color: $body-color;
      text-decoration: none;
      background-color: $gray-100;
    }

    &.active,
    &:active {
      transform: $push;
    }
  
    &:focus,
    &.focus {
      outline: 0;
      box-shadow: $btn-focus-box-shadow;
    }
  
    // Disabled comes first so active can properly restyle
    &.disabled,
    &:disabled {
      cursor: not-allowed;
      opacity: $btn-disabled-opacity;
      background-color: $white; // Default background-color
      transform: none; // Non push action
      @include box-shadow(none);
    }
  
    &:not(:disabled):not(.disabled):active,
    &:not(:disabled):not(.disabled).active {
      @include box-shadow($btn-active-box-shadow);
  
      &:focus {
        @include box-shadow($btn-focus-box-shadow, $btn-active-box-shadow);
      }
    }
  }

  .btn-transparent {
    border: none !important;
    background-color: transparent !important;
  }
  
  // Future-proof disabling of clicks on `<a>` elements
  a.btn.disabled,
  fieldset:disabled a.btn {
    pointer-events: none;
  }

  // Initial icon size
  .btn:not(.btn-sm) {
    i {
      @include font-size($btn-icon-size);
      line-height: 1;
    }
  }
  
  
  //
  // Alternate buttons
  //
  
  @each $color, $value in $theme-colors {
    .btn-#{$color} {
      @include button-variant($value);
    }
  }
  
  @each $color, $value in $theme-colors {
    .btn-outline-#{$color} {
      @include button-outline-variant($value);
    }
  }

  @each $color, $value in $theme-colors {
    .btn-ghost-#{$color} {
      @include button-ghost-variant($color, $value);
    }
  }

  @each $color, $value in $theme-colors {
    .btn-plain-#{$color} {
      @include hover {
        color: $white;
        background-color: $value;
        border-color: darken($value, 7.5%);
      }

      &.active {
        color: $white;
        background-color: $value;
        border-color: darken($value, 7.5%);
      }
    }
  }

  //
  // Icon buttons
  //
  
  .btn-icon {
    width: $btn-icon-width;
    height: $btn-icon-height;

    &.btn-sm {
      width: $btn-icon-width-sm;
      height: $btn-icon-height-sm;
      @include font-size($font-size-md);
    }
  }
  
  //
  // Link buttons
  //
  
  // Make a button look and behave like a link
  .btn-link {
    font-weight: $font-weight-normal;
    color: $link-color;
    text-decoration: $link-decoration;
  
    @include hover() {
      color: $link-hover-color;
      text-decoration: $link-hover-decoration;
    }
  
    &:focus,
    &.focus {
      text-decoration: $link-hover-decoration;
      box-shadow: none;
    }
  
    &:disabled,
    &.disabled {
      color: $btn-link-disabled-color;
      pointer-events: none;
    }
  
    // No need for an active state here
  }
  
  
  //
  // Button Sizes
  //
  
  .btn-lg {
    min-width: $btn-width-lg;
    font-weight: $btn-font-weight-lg;
    @include button-size($btn-padding-y-lg, $btn-padding-x-lg, $btn-font-size-lg, $btn-line-height-lg, $btn-border-radius-lg);
  }
  
  .btn-sm {
    @include button-size($btn-padding-y-sm, $btn-padding-x-sm, $btn-font-size-sm, $btn-line-height-sm, $btn-border-radius-sm);
  }
  
  
  //
  // Block button
  //
  
  .btn-block {
    display: block;
    width: 100%;
  
    // Vertically space out multiple block buttons
    + .btn-block {
      margin-top: $btn-block-spacing-y;
    }
  }
  
  // Specificity overrides
  input[type="submit"],
  input[type="reset"],
  input[type="button"] {
    &.btn-block {
      width: 100%;
    }
  }
